#All the environment variables are defined under Settings > CI/CD > Secret Variables section
image: docker:latest
variables:
  DOCKER_DRIVER: overlay2

services:
  - docker:dind

stages:
  - build_dev
  - build_prod
  - deploy_dev
  - deploy_prod

before_script:
  - apk update
  - echo "DOCKER_HOST=$DOCKER_HOST"
  - docker --version

build_dev:
  stage: build_dev
  image: $BASE_IMAGE_REPO
  only:
    - master
  script:
    - mvn clean package -P dev

build_prod:
  stage: build_prod
  only:
    - prod
  script:
    - mvn clean package -P prod


deploy_dev:
  stage: deploy_dev
  image: $BASE_IMAGE_REPO
  script:
    # Added to varify the automated deployment
    # Install python requirements
    #    - apk update
    #    - apk upgrade
    #    - apk add util-linux pciutils usbutils coreutils binutils findutils grep
    #    - apk add python python-dev py-pip

    # AWS configs
    - export AWS_ACCESS_KEY_ID=$AWS_ACCESS_KEY_ID
    - export AWS_DEFAULT_REGION=$AWS_DEFAULT_REGION
    - export AWS_SECRET_ACCESS_KEY=$AWS_SECRET_ACCESS_KEY
    - echo `aws ecr get-login --no-include-email --region $AWS_DEFAULT_REGION` | sh
    # Install awscli
    #    - pip install awscli

    - mvn clean package -P dev docker:build docker:push
    # Configure deploy.json
    #- cd deployment
    #- sed -i -e "s/N_ENV/$NODE_ENV_DEVELOPMENT/g" deploy.json
    #- sed -i -e "s/REPO/$REPO_DEV/g" deploy.json
    #- sed -i -e "s/TAG/$CI_BUILD_REF_NAME/g" deploy.json

    # Update task and service
    #- aws ecs register-task-definition --region <your-ecs-region> --cli-input-json file://deploy.json >> temp.json
    #- REV=`grep  '"revision"' temp.json | awk '{print $2}'`
    #- echo $REV
    #- aws ecs update-service --cluster <ecs-cluster-name> --service <ecs-service-name> --task-definition <your-ecs-task-name>:${REV} --region <your-ecs-region>
  only:
    - master
  when: manual

deploy_prod:
  stage: deploy_prod
  image: $BASE_IMAGE_REPO
  script:
    # Install python requirements
    #    - apk update
    #    - apk upgrade
    #    - apk add util-linux pciutils usbutils coreutils binutils findutils grep
    #    - apk add python python-dev py-pip

    # AWS configs
    - export AWS_ACCESS_KEY_ID=$AWS_ACCESS_KEY_ID
    - export AWS_DEFAULT_REGION=$AWS_DEFAULT_REGION
    - export AWS_SECRET_ACCESS_KEY=$AWS_SECRET_ACCESS_KEY
    - echo `aws ecr get-login --no-include-email --region $AWS_DEFAULT_REGION` | sh

    # Install awscli
    #    - pip install awscli

    - mvn clean package -P prod docker:build docker:push
    # Configure deploy.json
    #- cd deployment
    #- sed -i -e "s/N_ENV/$NODE_ENV_PRODUCTION/g" deploy.json
    #- sed -i -e "s/REPO/$REPO_PROD/g" deploy.json
    #- sed -i -e "s/TAG/$CI_BUILD_REF_NAME/g" deploy.json

    # Update task and service
    #- aws ecs register-task-definition --region  <your-ecs-region> --cli-input-json file://deploy.json >> temp.json
    #- REV=`grep  '"revision"' temp.json | awk '{print $2}'`
    #- echo $REV
    #- aws ecs update-service --cluster <ecs-cluster-name> --service <ecs-service-name> --task-definition <your-ecs-task-name>:${REV} --region <your-ecs-region>
  only:
    - prod
  when: manual
